Index: pjproject/trunk/build.symbian/pjsua_libU.def
===================================================================
--- pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1417)
+++ pjproject/trunk/build.symbian/pjsua_libU.def	(revision 1417)
@@ -0,0 +1,114 @@
+EXPORTS
+	pjsip_cred_dup                           @ 1 NONAME
+	pjsua_acc_add                            @ 2 NONAME
+	pjsua_acc_add_local                      @ 3 NONAME
+	pjsua_acc_config_default                 @ 4 NONAME
+	pjsua_acc_create_request                 @ 5 NONAME
+	pjsua_acc_create_uac_contact             @ 6 NONAME
+	pjsua_acc_create_uas_contact             @ 7 NONAME
+	pjsua_acc_del                            @ 8 NONAME
+	pjsua_acc_enum_info                      @ 9 NONAME
+	pjsua_acc_find_for_incoming              @ 10 NONAME
+	pjsua_acc_find_for_outgoing              @ 11 NONAME
+	pjsua_acc_get_count                      @ 12 NONAME
+	pjsua_acc_get_default                    @ 13 NONAME
+	pjsua_acc_get_info                       @ 14 NONAME
+	pjsua_acc_is_valid                       @ 15 NONAME
+	pjsua_acc_modify                         @ 16 NONAME
+	pjsua_acc_set_default                    @ 17 NONAME
+	pjsua_acc_set_online_status              @ 18 NONAME
+	pjsua_acc_set_registration               @ 19 NONAME
+	pjsua_acc_set_transport                  @ 20 NONAME
+	pjsua_buddy_add                          @ 21 NONAME
+	pjsua_buddy_config_default               @ 22 NONAME
+	pjsua_buddy_del                          @ 23 NONAME
+	pjsua_buddy_get_info                     @ 24 NONAME
+	pjsua_buddy_is_valid                     @ 25 NONAME
+	pjsua_buddy_subscribe_pres               @ 26 NONAME
+	pjsua_call_answer                        @ 27 NONAME
+	pjsua_call_dial_dtmf                     @ 28 NONAME
+	pjsua_call_dump                          @ 29 NONAME
+	pjsua_call_get_conf_port                 @ 30 NONAME
+	pjsua_call_get_count                     @ 31 NONAME
+	pjsua_call_get_info                      @ 32 NONAME
+	pjsua_call_get_max_count                 @ 33 NONAME
+	pjsua_call_get_user_data                 @ 34 NONAME
+	pjsua_call_hangup                        @ 35 NONAME
+	pjsua_call_hangup_all                    @ 36 NONAME
+	pjsua_call_has_media                     @ 37 NONAME
+	pjsua_call_is_active                     @ 38 NONAME
+	pjsua_call_make_call                     @ 39 NONAME
+	pjsua_call_reinvite                      @ 40 NONAME
+	pjsua_call_send_im                       @ 41 NONAME
+	pjsua_call_send_typing_ind               @ 42 NONAME
+	pjsua_call_set_hold                      @ 43 NONAME
+	pjsua_call_set_user_data                 @ 44 NONAME
+	pjsua_call_xfer                          @ 45 NONAME
+	pjsua_call_xfer_replaces                 @ 46 NONAME
+	pjsua_codec_get_param                    @ 47 NONAME
+	pjsua_codec_set_param                    @ 48 NONAME
+	pjsua_codec_set_priority                 @ 49 NONAME
+	pjsua_conf_add_port                      @ 50 NONAME
+	pjsua_conf_adjust_rx_level               @ 51 NONAME
+	pjsua_conf_adjust_tx_level               @ 52 NONAME
+	pjsua_conf_connect                       @ 53 NONAME
+	pjsua_conf_disconnect                    @ 54 NONAME
+	pjsua_conf_get_active_ports              @ 55 NONAME
+	pjsua_conf_get_max_ports                 @ 56 NONAME
+	pjsua_conf_get_port_info                 @ 57 NONAME
+	pjsua_conf_get_signal_level              @ 58 NONAME
+	pjsua_conf_remove_port                   @ 59 NONAME
+	pjsua_config_default                     @ 60 NONAME
+	pjsua_config_dup                         @ 61 NONAME
+	pjsua_create                             @ 62 NONAME
+	pjsua_destroy                            @ 63 NONAME
+	pjsua_dump                               @ 64 NONAME
+	pjsua_enum_accs                          @ 65 NONAME
+	pjsua_enum_buddies                       @ 66 NONAME
+	pjsua_enum_calls                         @ 67 NONAME
+	pjsua_enum_codecs                        @ 68 NONAME
+	pjsua_enum_conf_ports                    @ 69 NONAME
+	pjsua_enum_snd_devs                      @ 70 NONAME
+	pjsua_enum_transports                    @ 71 NONAME
+	pjsua_get_buddy_count                    @ 72 NONAME
+	pjsua_get_ec_tail                        @ 73 NONAME
+	pjsua_get_pjmedia_endpt                  @ 74 NONAME
+	pjsua_get_pjsip_endpt                    @ 75 NONAME
+	pjsua_get_pool_factory                   @ 76 NONAME
+	pjsua_get_snd_dev                        @ 77 NONAME
+	pjsua_handle_events                      @ 78 NONAME
+	pjsua_im_send                            @ 79 NONAME
+	pjsua_im_typing                          @ 80 NONAME
+	pjsua_init                               @ 81 NONAME
+	pjsua_logging_config_default             @ 82 NONAME
+	pjsua_logging_config_dup                 @ 83 NONAME
+	pjsua_media_config_default               @ 84 NONAME
+	pjsua_media_transports_create            @ 85 NONAME
+	pjsua_msg_data_init                      @ 86 NONAME
+	pjsua_perror                             @ 87 NONAME
+	pjsua_player_create                      @ 88 NONAME
+	pjsua_player_destroy                     @ 89 NONAME
+	pjsua_player_get_conf_port               @ 90 NONAME
+	pjsua_player_get_port                    @ 91 NONAME
+	pjsua_player_set_pos                     @ 92 NONAME
+	pjsua_playlist_create                    @ 93 NONAME
+	pjsua_pool_create                        @ 94 NONAME
+	pjsua_pres_dump                          @ 95 NONAME
+	pjsua_reconfigure_logging                @ 96 NONAME
+	pjsua_recorder_create                    @ 97 NONAME
+	pjsua_recorder_destroy                   @ 98 NONAME
+	pjsua_recorder_get_conf_port             @ 99 NONAME
+	pjsua_recorder_get_port                  @ 100 NONAME
+	pjsua_set_ec                             @ 101 NONAME
+	pjsua_set_no_snd_dev                     @ 102 NONAME
+	pjsua_set_null_snd_dev                   @ 103 NONAME
+	pjsua_set_snd_dev                        @ 104 NONAME
+	pjsua_start                              @ 105 NONAME
+	pjsua_transport_close                    @ 106 NONAME
+	pjsua_transport_config_default           @ 107 NONAME
+	pjsua_transport_config_dup               @ 108 NONAME
+	pjsua_transport_create                   @ 109 NONAME
+	pjsua_transport_get_info                 @ 110 NONAME
+	pjsua_transport_register                 @ 111 NONAME
+	pjsua_transport_set_enable               @ 112 NONAME
+	pjsua_verify_sip_url                     @ 113 NONAME
Index: pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1416)
+++ pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1417)
@@ -8,4 +8,5 @@
 MACRO		PJ_M_I386=1
 MACRO		PJ_SYMBIAN=1
+MACRO		PJ_DLL=1
 
 // Test files
@@ -26,5 +27,5 @@
 
 LIBRARY		esock.lib insock.lib charconv.lib euser.lib estlib.lib eexe.lib
-STATICLIBRARY   null_audio.lib pjsua_lib.lib pjsip_ua.lib pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib pjnath.lib pjlib_util.lib pjlib.lib ecrt0.lib
+LIBRARY		null_audio.lib pjsua_lib.lib pjsip_ua.lib pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib pjnath.lib pjlib_util.lib pjlib.lib ecrt0.lib
 CAPABILITY	None
 
Index: pjproject/trunk/pjlib/include/pj/guid.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/guid.h	(revision 1416)
+++ pjproject/trunk/pjlib/include/pj/guid.h	(revision 1417)
@@ -56,6 +56,14 @@
  * Regardless of the actual length of the GUID, it will not exceed
  * PJ_GUID_MAX_LENGTH characters.
+ *
+ * @see pj_GUID_STRING_LENGTH()
+ * @see PJ_GUID_MAX_LENGTH
  */
-extern const unsigned PJ_GUID_STRING_LENGTH;
+PJ_DECL_DATA(const unsigned) PJ_GUID_STRING_LENGTH;
+
+/**
+ * Get #PJ_GUID_STRING_LENGTH constant.
+ */
+PJ_DECL(unsigned) pj_GUID_STRING_LENGTH();
 
 /**
Index: pjproject/trunk/pjlib/include/pj/pool.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/pool.h	(revision 1416)
+++ pjproject/trunk/pjlib/include/pj/pool.h	(revision 1417)
@@ -615,6 +615,13 @@
  * This constant denotes the exception number that will be thrown by default
  * memory factory policy when memory allocation fails.
- */
-extern int PJ_NO_MEMORY_EXCEPTION;
+ *
+ * @see pj_NO_MEMORY_EXCEPTION()
+ */
+PJ_DECL_DATA(int) PJ_NO_MEMORY_EXCEPTION;
+
+/**
+ * Get #PJ_NO_MEMORY_EXCEPTION constant.
+ */ 
+PJ_DECL(int) pj_NO_MEMORY_EXCEPTION();
 
 /**
Index: pjproject/trunk/pjlib/src/pj/guid_simple.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/guid_simple.c	(revision 1416)
+++ pjproject/trunk/pjlib/src/pj/guid_simple.c	(revision 1417)
@@ -22,5 +22,10 @@
 #include <pj/string.h>
 
-const unsigned PJ_GUID_STRING_LENGTH=20;
+PJ_DEF_DATA(const unsigned) PJ_GUID_STRING_LENGTH=20;
+
+PJ_DEF(unsigned) pj_GUID_STRING_LENGTH()
+{
+    return PJ_GUID_STRING_LENGTH;
+}
 
 static void init_mac_address(unsigned char mac_addr[16])
Index: pjproject/trunk/pjlib/src/pj/guid_uuid.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/guid_uuid.c	(revision 1416)
+++ pjproject/trunk/pjlib/src/pj/guid_uuid.c	(revision 1417)
@@ -25,5 +25,10 @@
 #include <uuid/uuid.h>
 
-const unsigned PJ_GUID_STRING_LENGTH=36;
+PJ_DEF_DATA(const unsigned) PJ_GUID_STRING_LENGTH=36;
+
+PJ_DEF(unsigned) pj_GUID_STRING_LENGTH()
+{
+    return PJ_GUID_STRING_LENGTH;
+}
 
 PJ_DEF(pj_str_t*) pj_generate_unique_string(pj_str_t *str)
Index: pjproject/trunk/pjlib/src/pj/guid_win32.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/guid_win32.c	(revision 1416)
+++ pjproject/trunk/pjlib/src/pj/guid_win32.c	(revision 1417)
@@ -25,5 +25,10 @@
 
 
-const unsigned PJ_GUID_STRING_LENGTH=32;
+PJ_DEF_DATA(const unsigned) PJ_GUID_STRING_LENGTH=32;
+
+PJ_DEF(unsigned) pj_GUID_STRING_LENGTH()
+{
+    return PJ_GUID_STRING_LENGTH;
+}
 
 PJ_INLINE(void) hex2digit(unsigned value, char *p)
Index: pjproject/trunk/pjlib/src/pj/os_symbian.h
===================================================================
--- pjproject/trunk/pjlib/src/pj/os_symbian.h	(revision 1416)
+++ pjproject/trunk/pjlib/src/pj/os_symbian.h	(revision 1417)
@@ -26,7 +26,7 @@
 #include <e32cmn.h>
 #include <e32std.h>
-#include <ES_SOCK.H>
+#include <es_sock.h>
 #include <in_sock.h>
-#include <CHARCONV.H>
+#include <charconf.h>
 #include <utf.h>
 #include <e32cons.h>
Index: pjproject/trunk/pjlib/src/pj/pool.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/pool.c	(revision 1416)
+++ pjproject/trunk/pjlib/src/pj/pool.c	(revision 1417)
@@ -33,5 +33,10 @@
 #define LOG(expr)   PJ_LOG(6,expr)
 
-int PJ_NO_MEMORY_EXCEPTION;
+PJ_DEF_DATA(int) PJ_NO_MEMORY_EXCEPTION;
+
+PJ_DEF(int) pj_NO_MEMORY_EXCEPTION()
+{
+    return PJ_NO_MEMORY_EXCEPTION;
+}
 
 /*
Index: pjproject/trunk/pjmedia/include/pjmedia/errno.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/errno.h	(revision 1416)
+++ pjproject/trunk/pjmedia/include/pjmedia/errno.h	(revision 1417)
@@ -522,4 +522,21 @@
 
 
+/**
+ * Get error message for the specified error code. Note that this
+ * function is only able to decode PJMEDIA specific error code.
+ * Application should use pj_strerror(), which should be able to
+ * decode all error codes belonging to all subsystems (e.g. pjlib,
+ * pjmedia, pjsip, etc).
+ *
+ * @param status    The error code.
+ * @param buffer    The buffer where to put the error message.
+ * @param bufsize   Size of the buffer.
+ *
+ * @return	    The error message as NULL terminated string,
+ *                  wrapped with pj_str_t.
+ */
+PJ_DECL(pj_str_t) pjmedia_strerror( pj_status_t status, char *buffer,
+				    pj_size_t bufsize);
+
 
 PJ_END_DECL
Index: pjproject/trunk/pjmedia/include/pjmedia/rtcp.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/rtcp.h	(revision 1416)
+++ pjproject/trunk/pjmedia/include/pjmedia/rtcp.h	(revision 1417)
@@ -310,6 +310,6 @@
  * @return		    PJ_SUCCESS on success.
  */
-PJ_DEF(pj_status_t) pjmedia_rtcp_get_ntp_time(const pjmedia_rtcp_session *sess,
-					      pjmedia_rtcp_ntp_rec *ntp);
+PJ_DECL(pj_status_t) pjmedia_rtcp_get_ntp_time(const pjmedia_rtcp_session *sess,
+					       pjmedia_rtcp_ntp_rec *ntp);
 
 
Index: pjproject/trunk/pjmedia/src/pjmedia/alaw_ulaw.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/alaw_ulaw.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/alaw_ulaw.c	(revision 1417)
@@ -117,6 +117,5 @@
  * John Wiley & Sons, pps 98-111 and 472-476.
  */
-PJ_DEF(pj_uint8_t)
-pjmedia_linear2alaw(
+PJ_DEF(pj_uint8_t) pjmedia_linear2alaw(
 	int		pcm_val)	/* 2's complement (16-bit range) */
 {
@@ -153,6 +152,5 @@
  *
  */
-PJ_DEF(int)
-pjmedia_alaw2linear(
+PJ_DEF(int) pjmedia_alaw2linear(
 	unsigned a_val)
 {
@@ -209,6 +207,5 @@
  * John Wiley & Sons, pps 98-111 and 472-476.
  */
-PJ_DECL(unsigned char)
-pjmedia_linear2ulaw(
+PJ_DEF(unsigned char) pjmedia_linear2ulaw(
 	int		pcm_val)	/* 2's complement (16-bit range) */
 {
@@ -251,6 +248,5 @@
  * original code word. This is in keeping with ISDN conventions.
  */
-PJ_DEF(int)
-pjmedia_ulaw2linear(
+PJ_DEF(int) pjmedia_ulaw2linear(
 	unsigned char	u_val)
 {
@@ -277,6 +273,5 @@
 
 /* A-law to u-law conversion */
-PJ_DEF(unsigned char)
-pjmedia_alaw2ulaw(
+PJ_DEF(unsigned char) pjmedia_alaw2ulaw(
 	unsigned char	aval)
 {
@@ -287,6 +282,5 @@
 
 /* u-law to A-law conversion */
-PJ_DEF(unsigned char)
-pjmedia_ulaw2alaw(
+PJ_DEF(unsigned char) pjmedia_ulaw2alaw(
 	unsigned char	uval)
 {
Index: pjproject/trunk/pjmedia/src/pjmedia/codec.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/codec.c	(revision 1417)
@@ -51,6 +51,5 @@
  * Register a codec factory.
  */
-PJ_DEF(pj_status_t) 
-pjmedia_codec_mgr_register_factory( pjmedia_codec_mgr *mgr,
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_register_factory( pjmedia_codec_mgr *mgr,
 				    pjmedia_codec_factory *factory)
 {
@@ -101,7 +100,7 @@
  * Unregister a codec factory.
  */
-PJ_DEF(pj_status_t) 
-pjmedia_codec_mgr_unregister_factory(pjmedia_codec_mgr *mgr, 
-				     pjmedia_codec_factory *factory)
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_unregister_factory(
+				pjmedia_codec_mgr *mgr, 
+				pjmedia_codec_factory *factory)
 {
     unsigned i;
@@ -140,6 +139,5 @@
  * Enum all codecs.
  */
-PJ_DEF(pj_status_t)
-pjmedia_codec_mgr_enum_codecs(pjmedia_codec_mgr *mgr, 
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_enum_codecs(pjmedia_codec_mgr *mgr, 
 			      unsigned *count, 
 			      pjmedia_codec_info codecs[],
@@ -171,6 +169,5 @@
  * Get codec info for static payload type.
  */
-PJ_DEF(pj_status_t) 
-pjmedia_codec_mgr_get_codec_info( pjmedia_codec_mgr *mgr,
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_get_codec_info( pjmedia_codec_mgr *mgr,
 				  unsigned pt,
 				  const pjmedia_codec_info **p_info)
@@ -223,6 +220,5 @@
  * and so on, up to the maximum count specified in the argument.
  */
-PJ_DEF(pj_status_t) 
-pjmedia_codec_mgr_find_codecs_by_id( pjmedia_codec_mgr *mgr,
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_find_codecs_by_id( pjmedia_codec_mgr *mgr,
 				     const pj_str_t *codec_id,
 				     unsigned *count,
@@ -307,8 +303,8 @@
  * priorities of all those codecs.
  */
-PJ_DEF(pj_status_t)
-pjmedia_codec_mgr_set_codec_priority(pjmedia_codec_mgr *mgr, 
-				     const pj_str_t *codec_id,
-				     pj_uint8_t prio)
+PJ_DEF(pj_status_t) pjmedia_codec_mgr_set_codec_priority(
+				pjmedia_codec_mgr *mgr, 
+				const pj_str_t *codec_id,
+				pj_uint8_t prio)
 {
     unsigned i, found = 0;
Index: pjproject/trunk/pjmedia/src/pjmedia/conference.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 1417)
@@ -819,5 +819,5 @@
  * Change TX and RX settings for the port.
  */
-PJ_DECL(pj_status_t) pjmedia_conf_configure_port( pjmedia_conf *conf,
+PJ_DEF(pj_status_t) pjmedia_conf_configure_port( pjmedia_conf *conf,
 						  unsigned slot,
 						  pjmedia_port_op tx,
@@ -980,5 +980,5 @@
  * Get total number of ports connections currently set up in the bridge.
  */
-PJ_DECL(unsigned) pjmedia_conf_get_connect_count(pjmedia_conf *conf)
+PJ_DEF(unsigned) pjmedia_conf_get_connect_count(pjmedia_conf *conf)
 {
     return conf->connect_cnt;
Index: pjproject/trunk/pjmedia/src/pjmedia/echo_common.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/echo_common.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/echo_common.c	(revision 1417)
@@ -22,5 +22,5 @@
 #include <pj/assert.h>
 #include <pj/pool.h>
-
+#include "echo_internal.h"
 
 typedef struct ec_operations ec_operations;
@@ -56,27 +56,4 @@
 
 
-
-/*
- * Simple echo suppressor
- */
-PJ_DECL(pj_status_t) echo_supp_create(pj_pool_t *pool,
-				      unsigned clock_rate,
-				      unsigned samples_per_frame,
-				      unsigned tail_ms,
-				      unsigned latency_ms,
-				      unsigned options,
-				      void **p_state );
-PJ_DECL(pj_status_t) echo_supp_destroy(void *state);
-PJ_DECL(pj_status_t) echo_supp_playback(void *state,
-					pj_int16_t *play_frm );
-PJ_DECL(pj_status_t) echo_supp_capture(void *state,
-				       pj_int16_t *rec_frm,
-				       unsigned options );
-PJ_DECL(pj_status_t) echo_supp_cancel_echo(void *state,
-					   pj_int16_t *rec_frm,
-					   const pj_int16_t *play_frm,
-					   unsigned options,
-					   void *reserved );
-
 static struct ec_operations echo_supp_op = 
 {
@@ -94,23 +71,4 @@
  */
 #if defined(PJMEDIA_HAS_SPEEX_AEC) && PJMEDIA_HAS_SPEEX_AEC!=0
-PJ_DECL(pj_status_t) speex_aec_create(pj_pool_t *pool,
-				      unsigned clock_rate,
-				      unsigned samples_per_frame,
-				      unsigned tail_ms,
-				      unsigned latency_ms,
-				      unsigned options,
-				      void **p_state );
-PJ_DECL(pj_status_t) speex_aec_destroy(void *state );
-PJ_DECL(pj_status_t) speex_aec_playback(void *state,
-				        pj_int16_t *play_frm );
-PJ_DECL(pj_status_t) speex_aec_capture(void *state,
-				       pj_int16_t *rec_frm,
-				       unsigned options );
-PJ_DECL(pj_status_t) speex_aec_cancel_echo(void *state,
-					   pj_int16_t *rec_frm,
-					   const pj_int16_t *play_frm,
-					   unsigned options,
-					   void *reserved );
-
 static struct ec_operations aec_op = 
 {
Index: pjproject/trunk/pjmedia/src/pjmedia/echo_internal.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/echo_internal.h	(revision 1417)
+++ pjproject/trunk/pjmedia/src/pjmedia/echo_internal.h	(revision 1417)
@@ -0,0 +1,71 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_ECHO_INTERNAL_H__
+#define __PJMEDIA_ECHO_INTERNAL_H__
+
+#include <pjmedia/types.h>
+
+PJ_BEGIN_DECL
+
+/*
+ * Simple echo suppressor
+ */
+PJ_DECL(pj_status_t) echo_supp_create(pj_pool_t *pool,
+				      unsigned clock_rate,
+				      unsigned samples_per_frame,
+				      unsigned tail_ms,
+				      unsigned latency_ms,
+				      unsigned options,
+				      void **p_state );
+PJ_DECL(pj_status_t) echo_supp_destroy(void *state);
+PJ_DECL(pj_status_t) echo_supp_playback(void *state,
+					pj_int16_t *play_frm );
+PJ_DECL(pj_status_t) echo_supp_capture(void *state,
+				       pj_int16_t *rec_frm,
+				       unsigned options );
+PJ_DECL(pj_status_t) echo_supp_cancel_echo(void *state,
+					   pj_int16_t *rec_frm,
+					   const pj_int16_t *play_frm,
+					   unsigned options,
+					   void *reserved );
+
+PJ_DECL(pj_status_t) speex_aec_create(pj_pool_t *pool,
+				      unsigned clock_rate,
+				      unsigned samples_per_frame,
+				      unsigned tail_ms,
+				      unsigned latency_ms,
+				      unsigned options,
+				      void **p_state );
+PJ_DECL(pj_status_t) speex_aec_destroy(void *state );
+PJ_DECL(pj_status_t) speex_aec_playback(void *state,
+				        pj_int16_t *play_frm );
+PJ_DECL(pj_status_t) speex_aec_capture(void *state,
+				       pj_int16_t *rec_frm,
+				       unsigned options );
+PJ_DECL(pj_status_t) speex_aec_cancel_echo(void *state,
+					   pj_int16_t *rec_frm,
+					   const pj_int16_t *play_frm,
+					   unsigned options,
+					   void *reserved );
+
+
+PJ_END_DECL
+
+#endif
+
Index: pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 1417)
@@ -29,4 +29,5 @@
 #include <speex/speex_preprocess.h>
 
+#include "echo_internal.h"
 
 #define THIS_FILE	"echo_speex.c"
@@ -226,27 +227,4 @@
     return PJ_SUCCESS;
 }
-
-/*
- * Prototypes
- */
-PJ_DECL(pj_status_t) speex_aec_create(pj_pool_t *pool,
-				      unsigned clock_rate,
-				      unsigned samples_per_frame,
-				      unsigned tail_ms,
-				      unsigned latency_ms,
-				      unsigned options,
-				      void **p_state );
-PJ_DECL(pj_status_t) speex_aec_destroy(void *state );
-PJ_DECL(pj_status_t) speex_aec_playback(void *state,
-				        pj_int16_t *play_frm );
-PJ_DECL(pj_status_t) speex_aec_capture(void *state,
-				       pj_int16_t *rec_frm,
-				       unsigned options );
-PJ_DECL(pj_status_t) speex_aec_cancel_echo(void *state,
-					   pj_int16_t *rec_frm,
-					   const pj_int16_t *play_frm,
-					   unsigned options,
-					   void *reserved );
-
 
 enum
Index: pjproject/trunk/pjmedia/src/pjmedia/echo_suppress.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/echo_suppress.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/echo_suppress.c	(revision 1417)
@@ -26,4 +26,5 @@
 #include <pj/pool.h>
 
+#include "echo_internal.h"
 
 #define THIS_FILE			    "echo_suppress.c"
@@ -41,28 +42,4 @@
     unsigned		 tail_ms;
 } echo_supp;
-
-
-
-/*
- * Prototypes.
- */
-PJ_DECL(pj_status_t) echo_supp_create(pj_pool_t *pool,
-				      unsigned clock_rate,
-				      unsigned samples_per_frame,
-				      unsigned tail_ms,
-				      unsigned latency_ms,
-				      unsigned options,
-				      void **p_state );
-PJ_DECL(pj_status_t) echo_supp_destroy(void *state);
-PJ_DECL(pj_status_t) echo_supp_playback(void *state,
-					pj_int16_t *play_frm );
-PJ_DECL(pj_status_t) echo_supp_capture(void *state,
-				       pj_int16_t *rec_frm,
-				       unsigned options );
-PJ_DECL(pj_status_t) echo_supp_cancel_echo(void *state,
-					   pj_int16_t *rec_frm,
-					   const pj_int16_t *play_frm,
-					   unsigned options,
-					   void *reserved );
 
 
Index: pjproject/trunk/pjmedia/src/pjmedia/endpoint.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/endpoint.c	(revision 1417)
@@ -51,23 +51,4 @@
 
 
-/**
- * Defined in pjmedia/errno.c
- * 
- * Get error message for the specified error code. Note that this
- * function is only able to decode PJMEDIA specific error code.
- * Application should use pj_strerror(), which should be able to
- * decode all error codes belonging to all subsystems (e.g. pjlib,
- * pjmedia, pjsip, etc).
- *
- * @param status    The error code.
- * @param buffer    The buffer where to put the error message.
- * @param bufsize   Size of the buffer.
- *
- * @return	    The error message as NULL terminated string,
- *                  wrapped with pj_str_t.
- */
-PJ_DECL(pj_str_t) pjmedia_strerror( pj_status_t status, char *buffer,
-				    pj_size_t bufsize);
-
 
 /* Worker thread proc. */
Index: pjproject/trunk/pjmedia/src/pjmedia/g711.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 1417)
@@ -43,8 +43,4 @@
 #define SAMPLES_PER_FRAME   (8000 * PTIME / 1000)   /* 80 samples   */
 
-/* These are the only public functions exported to applications */
-PJ_DECL(pj_status_t) g711_init_factory (pjmedia_codec_factory *factory, 
-					pj_pool_t *pool);
-
 /* Prototypes for G711 factory */
 static pj_status_t g711_test_alloc( pjmedia_codec_factory *factory, 
Index: pjproject/trunk/pjmedia/src/pjmedia/mem_capture.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/mem_capture.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/mem_capture.c	(revision 1417)
@@ -52,5 +52,5 @@
 
 
-PJ_DECL(pj_status_t) pjmedia_mem_capture_create(pj_pool_t *pool,
+PJ_DEF(pj_status_t) pjmedia_mem_capture_create( pj_pool_t *pool,
 						void *buffer,
 						pj_size_t size,
@@ -105,6 +105,5 @@
  * end of buffer.
  */
-PJ_DEF(pj_status_t)
-pjmedia_mem_capture_set_eof_cb( pjmedia_port *port,
+PJ_DEF(pj_status_t) pjmedia_mem_capture_set_eof_cb( pjmedia_port *port,
 				void *user_data,
 				pj_status_t (*cb)(pjmedia_port *port,
Index: pjproject/trunk/pjmedia/src/pjmedia/mem_player.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/mem_player.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/mem_player.c	(revision 1417)
@@ -106,6 +106,5 @@
  * end of buffer.
  */
-PJ_DEF(pj_status_t) 
-pjmedia_mem_player_set_eof_cb( pjmedia_port *port,
+PJ_DEF(pj_status_t) pjmedia_mem_player_set_eof_cb( pjmedia_port *port,
 			       void *user_data,
 			       pj_status_t (*cb)(pjmedia_port *port,
Index: pjproject/trunk/pjmedia/src/pjmedia/sdp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 1416)
+++ pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 1417)
@@ -132,9 +132,8 @@
 }
 
-PJ_DEF(pjmedia_sdp_attr*) 
-pjmedia_sdp_attr_find (unsigned count, 
-		       pjmedia_sdp_attr *const attr_array[],
-		       const pj_str_t *name,
-		       const pj_str_t *c_fmt)
+PJ_DEF(pjmedia_sdp_attr*) pjmedia_sdp_attr_find (unsigned count, 
+				       pjmedia_sdp_attr *const attr_array[],
+				       const pj_str_t *name,
+				       const pj_str_t *c_fmt)
 {
     unsigned i;
@@ -159,9 +158,8 @@
 }
 
-PJ_DEF(pjmedia_sdp_attr*) 
-pjmedia_sdp_attr_find2(unsigned count, 
-		       pjmedia_sdp_attr *const attr_array[],
-		       const char *c_name,
-		       const pj_str_t *c_fmt)
+PJ_DEF(pjmedia_sdp_attr*) pjmedia_sdp_attr_find2(unsigned count, 
+				       pjmedia_sdp_attr *const attr_array[],
+				       const char *c_name,
+				       const pj_str_t *c_fmt)
 {
     pj_str_t name;
@@ -616,7 +614,7 @@
 }
 
-PJ_DEF(pjmedia_sdp_attr*) 
-pjmedia_sdp_media_find_attr(const pjmedia_sdp_media *m,
-			    const pj_str_t *name, const pj_str_t *fmt)
+PJ_DEF(pjmedia_sdp_attr*) pjmedia_sdp_media_find_attr(
+				const pjmedia_sdp_media *m,
+				const pj_str_t *name, const pj_str_t *fmt)
 {
     PJ_ASSERT_RETURN(m && name, NULL);
@@ -626,7 +624,7 @@
 
 
-PJ_DEF(pjmedia_sdp_attr*) 
-pjmedia_sdp_media_find_attr2(const pjmedia_sdp_media *m,
-			     const char *name, const pj_str_t *fmt)
+PJ_DEF(pjmedia_sdp_attr*) pjmedia_sdp_media_find_attr2(
+				const pjmedia_sdp_media *m,
+				const char *name, const pj_str_t *fmt)
 {
     PJ_ASSERT_RETURN(m && name, NULL);
@@ -641,14 +639,12 @@
 }
 
-PJ_DEF(unsigned) 
-pjmedia_sdp_media_remove_all_attr(pjmedia_sdp_media *m,
-				  const char *name)
+PJ_DEF(unsigned) pjmedia_sdp_media_remove_all_attr(pjmedia_sdp_media *m,
+						   const char *name)
 {
     return pjmedia_sdp_attr_remove_all(&m->attr_count, m->attr, name);
 }
 
-PJ_DEF(pj_status_t)
-pjmedia_sdp_media_remove_attr(pjmedia_sdp_media *m,
-			      pjmedia_sdp_attr *attr)
+PJ_DEF(pj_status_t) pjmedia_sdp_media_remove_attr(pjmedia_sdp_media *m,
+			      			  pjmedia_sdp_attr *attr)
 {
     return pjmedia_sdp_attr_remove(&m->attr_count, m->attr, attr);
@@ -1129,7 +1125,6 @@
  * Clone session
  */
-PJ_DEF(pjmedia_sdp_session*) 
-pjmedia_sdp_session_clone( pj_pool_t *pool,
-			   const pjmedia_sdp_session *rhs)
+PJ_DEF(pjmedia_sdp_session*) pjmedia_sdp_session_clone( pj_pool_t *pool,
+			   			const pjmedia_sdp_session *rhs)
 {
     pjmedia_sdp_session *sess;
